#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <inttypes.h>
#include "edit.h"


int main() {
	char input[300];
	char firstArg[100];//holds first command argument
	char secondArg[257];//holds second argument if necessary
	Line *head;

	head = NULL;
	printf("Welcome to LineEditor\n>");
	fgets(input,300,stdin);
	printf("\n");
	while(input[0] != 'q' || input[1] != '\n') {
		int length = 2;//used to get past the command letter and space
		/*
 		 * Read
 		 */
		if(input[0] == 'r' && input[1] == ' ') {
			while(input[length] != '\n') {
				firstArg[length-2] = input[length];
				length++;
			}
			if(length-2 == 0) {
				fprintf(stderr,"A file with no name cannot be read.\n");
			}
			else {
				firstArg[length-2] = '\0';
				readFile(firstArg,&head);
			}
		}
		/*
 		 * Write
 		 */
		else if(input[0] == 'w' && input[1] == ' ') {
			while(input[length] != '\n') {
				firstArg[length-2] = input[length];
				length++;
			}
			if(length-2 == 0) {
				fprintf(stderr,"A file with no name cannot be written to.\n");
			}
			else {
				firstArg[length-2] = '\0';
				writeFile(firstArg,head);
			}
		}
		/*
 		 * Insert
 		 */
		else if(input[0] == 'i' && input[1] == ' ') {
			int length2 = 0;
			int lineNum;
			int error = 0;
			while(input[length] != ' ') {
				if(input[length] == '\n') {//if hits a new line before a space
					fprintf(stderr,"The insert command takes two arguments.\n");
					error = 1;
					break;
				}
				else {
					firstArg[length-2] = input[length];
					length ++;
				}
			}
			if(!error) {
				char *pos;
				firstArg[length-2] = '\0';
				lineNum = (int)strtol(firstArg,&pos,10);
				//strtol stores first non number character in pos
				if(*pos != '\0') {
					fprintf(stderr,"The insert command needs the line number to be a base ten integer.\n");
					error = 1;
				}
				if(!error) {
					length2 = length+1;
					while(input[length2] != '\n') {
						secondArg[length2 - (length+1)] = input[length2];
						length2++;
					}
					//go ahead and put newline and zero byte at end
					secondArg[(length2)-(length+1)] = '\n';
					secondArg[(length2+1)-(length+1)] = '\0';
					insertLine(lineNum,secondArg,&head);
				}
			}
		}	
		/*
 		 * Delete
 		 */
		else if(input[0] == 'd' && input[1] == ' ') {
			int lineNum = 0;
			char *pos;
			while(input[length] != '\n') {
                                firstArg[length-2] = input[length];
                                length++;
                        }
                        if(length-2 == 0) {
                                fprintf(stderr,"The delete command needs a line number to delete.\n");
                        }
                        else {
                                firstArg[length-2] = '\0';
				lineNum = (int)strtol(firstArg,&pos,10);
				if(*pos != '\0') {
					fprintf(stderr,"Please enter an integer in base 10.\n");
				}
				else {
					Line *success;
					success = deleteLine(lineNum,&head);
					if(success != NULL) {
						//due to implementation of move, I must free it here
						free(success);
					}
				}
			}
		}
		/*
 		 * Filter
 		 */
		else if(input[0] == 'f' && input[1] == ' ') {
			int forwardS = 2;
			int temp = 0;
			//loop to find rightmost forward slash
			while(input[length] != '\n') {
                        	firstArg[length-2] = input[length];
				if(input[length] == '/') {
					forwardS = length+1;
				}
                                length++;
                        }
                        if(length-2 == 0) {
                                fprintf(stderr,"The f command needs a bash command to call.\n");
                        }
			else {
				temp = 0;
				//copy command over
				while(length - forwardS) {
					firstArg[temp] = input[forwardS];
					temp++;
					forwardS++;
				}
				firstArg[temp] = '\0';
				pipeCommand(firstArg,head);
			}
		}
		/*
 		 * Print
 		 */
		else if(input[0] == 'p' && (input[1] == ' ' || input[1] == '\n')) {
			if(input[1] == '\n') {
				//print all, -1 is special value
				print(-1,-1,head);
			}
			else {
				int error = 0;
				while(input[length] != '\n') {
                                	length++;
                         	}
                         	if(length-2 == 0) {
					print(-1,-1,head);
                         	}
                         	else {
					length = 2;//resetting for checks on line numbers
					while(input[length] != ' ') {
                                		if(input[length] == '\n') {
                                        		fprintf(stderr,"The insert command takes two, or zero, arguments.\n");
                                        		error = 1;
                                        		break;
                                		}
                                		else {
                                        		firstArg[length-2] = input[length];
                                        		length ++;
                                		}
                        		}
                        		if(!error) {
						int startLine = 0;
						char *pos;
                                		firstArg[length-2] = '\0';
                                		startLine = (int)strtol(firstArg,&pos,10);
                                		if(*pos != '\0') {
                                        		fprintf(stderr,"The first argument of the print command needs to be a base ten integer.\n");
                                        		error = 1;
                                		}
                                		if(!error) {
							int length2 = 0;// two variables required for handleing of second argument
							int endLine = 0;
                                        		length2 = length+1;
                                        		while(input[length2] != '\n') {
                                                		secondArg[length2 - (length+1)] = input[length2];
                                                		length2++;
                                        		}
                                        		secondArg[length2-(length+1)] = '\0';
							endLine = (int)strtol(secondArg,&pos,10);
							if(*pos != '\0') {
								fprintf(stderr,"The second argument of the print command needs to be a base ten integer.\n");
								error = 1;
							}
							if(!error) {
                                        			print(startLine,endLine,head);
                                        		}
                                         	}
                             		}
				}
			}
		}
		/*
 		 * Change
 		 */
		else if(input[0] == 'c' && input[1] == ' ') {
			int length2 = 0;
                        int lineNum;
                        int error = 0;
                        while(input[length] != ' ') {
                                if(input[length] == '\n') {
                                        fprintf(stderr,"The change command takes two arguments.\n");
                                        error = 1;
                                        break;
                                }
                                else {
                                        firstArg[length-2] = input[length];
                                        length ++;
                                }
                        }
                        if(!error) {
				char *pos;
                                firstArg[length-2] = '\0';
                                lineNum = (int)strtol(firstArg,&pos,10);
                                if(*pos != '\0') {
                                        fprintf(stderr,"The change command needs a base ten integer for the line number.\n");
                                        error = 1;
                                }
                                if(!error) {
                                        length2 = length+1;
                                        while(input[length2] != '\n') {
                                                secondArg[length2 - (length+1)] = input[length2];
                                                length2++;
                                        }
					//again add newline and zero byte
                                        secondArg[length2-(length+1)] = '\n';
					secondArg[(length2+1)-(length+1)] = '\0';
                                        changeLine(lineNum,secondArg,head);
                                        
				}
			}
		}	
		/*
 		 * Move
 		 */
		else if(input[0] == 'm' && input[1] == ' ') {
			int error = 0;
			while(input[length] != ' ') {
                        	if(input[length] == '\n') {
                                	fprintf(stderr,"The move command takes two arguments.\n");
                                        error = 1;
                                        break;
                                }
                                else {
                                	firstArg[length-2] = input[length];
                                        length ++;
                                }
			}			
                        if(!error) {
                        	int startLine = 0;
                                char *pos;
                                firstArg[length-2] = '\0';
                                startLine = (int)strtol(firstArg,&pos,10);
                                if(*pos != '\0') {
                                	fprintf(stderr,"The first argument of the move command needs to be a base ten integer.\n");
                                        error = 1;
                                }
                                if(!error) {
                                	int length2 = 0;// two variables required for handeling of second argument
                                        int endLine = 0;
                                        length2 = length+1;
                                        while(input[length2] != '\n') {
                                        	secondArg[length2 - (length+1)] = input[length2];
                                                length2++;
                                        }
                                        secondArg[length2-(length+1)] = '\0';
                                        endLine = (int)strtol(secondArg,&pos,10);
                                        if(*pos != '\0') {
                                        	fprintf(stderr,"The second argument of the move command needs to be a base ten integer.\n");
                                                error = 1;
                                        }
                                        if(!error) {
                                                move(startLine,endLine,&head);
					}
				}
			}
		}
		/*
 		 * Remove
 		 */
		else if(input[0] == 'x' && (input[1] == ' ' || input[1] == '\n')) {
			destroy(&head);
		}
		else {
			printf("List of commands:\nr filename     loads a text file with filename \"filename\" into the editor\n");
			printf("w filename     writes the current file to file \"filename\"\ni line_number line_text     inserts \"line_text\" after line \"line_number\"\n");
			printf("d line_number    deletes line \"line_number\"\nf program    filters file through the unix command \"program\"\n");
			printf("p begin_line end_line    prints the file from \"begin_line\" to \"end_line\", if neither is included the entire file is printed to the screen\n");
			printf("c line_number line_text    changes the text at \"line_number\" to be \"line_text\"\nm from_line to_line    moves line \"from_line\" to after");
			printf(" line \"to_line\"\nx     removes the current file from memory\nq    exits the LineEditor\n\n");
		}

		printf(">");
		fgets(input,300,stdin);
		printf("\n");
	}
	destroy(&head);//if quit free the current list
	return(0);
}
